﻿# zyklischerZaehler.py

class EinfacherZaehler:
    # Konstruktor:
    def __init__(self):
        # Attribut:
        self.stand=0

    # Methoden:
    # der muss zaehlen können
    def zaehle(self):
        self.stand+=1
        
    # und den stand anzeigen können
    def zeigeStand(self):
        return self.stand


# Vererbung:
class ZyklischerZaehler(EinfacherZaehler):
    def __init__(self, maximalWert):
        EinfacherZaehler.__init__(self)
        self.maximalWert=maximalWert

    # zaehlen muss den Maximalwert beachten
    def zaehle(self):
        self.stand+=1
        if self.stand==self.maximalWert:
            self.stand=0
    #  Die Methode zum Anzeigen von stand erbt er.

zyklischerZaehler=ZyklischerZaehler(3)
print( zyklischerZaehler.zeigeStand() )
zyklischerZaehler.zaehle()
print( zyklischerZaehler.zeigeStand() )
zyklischerZaehler.zaehle()
print( zyklischerZaehler.zeigeStand() )
zyklischerZaehler.zaehle()
print( zyklischerZaehler.zeigeStand() )
# Ärgerlicher:
print( zyklischerZaehler.stand )
print( "direkter Zugriff fuehrt zu undefiniertem Zustand!" )
zyklischerZaehler.stand=5
print( zyklischerZaehler.stand )



